Subject: Re: bug#76142: [PATCH] Eglot: do not activate unsupported menu items
From: João Távora <[email-masked]>
To: Felician Nemeth <[email-masked]>
Cc: [email-masked]
Date: Sat, 8 Feb 2025 13:31:34 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

On Sat, Feb 8, 2025 at 11:45 AM Felician Nemeth
<[email-masked]> wrote:
>
> > Thanks, felicián.  Feel free to push and close this issue.
>
> I don't have access rights to push.

Ok, I pushed it for you.  I'll close the bug, but we can keep talking.

>
> > Re outline mode, I'm not sure it would help.  You can already use tab
> > to navigate buttons.
>
> I have not used call hierarchies long enough to have a strong opinion,
> but maybe starting with fully open hierarchy is more useful than the
> current closed one.

Opening the first node is feasible (and logical, since why else would
you invoke the hierarchy commands?) but expanding the whole tree
is impossible.  In general, especially when both directions are considered,
the tree is infinite.

> For example:
>
> [-]  ∘ funcb
>  |-[-]  ← funca
>  |  `-   ← main
>  `-   ← main
>
> vs:
>
> [+]  ∘ funcb
>
> And in the former case, 'Up' and 'Next Same Level' commands can be
> useful.

indeed.

> I don't know.  If Eglot just relies on the tree-widget library, then
> maybe that library should be enhanced with more navigation commands
> instead.

Yes.  tree-widget.el could come with some kind of tree-widget-mode with such
commands.  outline-mode is not a good choice, it's meant for plain text
with some markup.

I also don't know what other LSP extensions do with this graph.  If you have
more ideas to make it more interactive, pretty, etc, feel free to let me know
or push patches.  I think you should have commit rights to push to Eglot
directly.

João